/********************************************************************************
 * ePIMSs $Source: OtherRqstForm.java $
 * ePIMSs $Project: com.epimss.lab $
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author: st.clair.clarke $
 *
 * @source $Source: OtherRqstForm.java $
 * @path $FPath: src-java/com/epimss/lab/ui/misc $

 * @project $Project: com.epimss.lab $
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author: st.clair.clarke $
 * @lastChangedDate $Date: 2011/04/17 12:11:08 $
 *
 * @version $Revision: 1.0 $ $Date: 2011/04/17 12:11:08 $
 *
 * @changeRequest $CR: com.epimss.lab|000033 $
 * @state $State: Develop/Test $
 ********************************************************************************/


package _com.epimss.lab.ui.misc;


// import com.gurock.smartinspect.SiAuto;

import com.richclientgui.toolbox.propagate.PropagateComposite;

import org.eclipse.swt.SWT;

import org.eclipse.swt.custom.CLabel;

import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;

import org.eclipse.ui.forms.widgets.FormToolkit;


/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  April 17, 2011 12:12:23 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
public class OtherRqstForm extends Composite
{
    //~ Instance fields --------------------------------------------------------

    private final FormToolkit  toolkit           = new FormToolkit( Display.getCurrent() );

    private CLabel             requestCLbl;

    private PropagateComposite parentPrpgteCmpst;

    private Text               requestTxt;

    //~ public -----------------------------------------------------------------

    /**
     * Creates a new <code>OtherRqstForm</code> object.
     *
     * @created  April 17, 2011 12:12:23 PM by St Clair Clarke
     *
     * @param    parent  <code>Composite</code> TODO!
     * @param    style   <code>int</code> TODO!
     *
     * @since    1.0
     */
    public OtherRqstForm( Composite parent, int style )
    {
        super( parent, style );

        try
        {
            createContents();

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.misc.OtherRqstForm.OtherRqstForm(parent, style, )" + e );

            // SiAuto.main.logException(
            // "com.epimss.lab.ui.misc.OtherRqstForm.OtherRqstForm(parent, style)",
            // e );

        }   // end try-catch

    }   // end ctor OtherRqstForm

    //~ Methods ----------------------------------------------------------------

    /**
     * The <code>createContents()</code> method TODO!
     *
     * @created  April 17, 2011 12:18:52 PM by St Clair Clarke
     * @since    1.0
     */
    private void createContents()
    {
        addDisposeListener( new DisposeListener()
            {
                @Override
                public void widgetDisposed( DisposeEvent e )
                {
                    toolkit.dispose();

                }   // end method widgetDisposed

            } );
        toolkit.adapt( this );
        toolkit.paintBordersFor( this );
        setLayout( new FillLayout( SWT.HORIZONTAL ) );

        {
            parentPrpgteCmpst = new PropagateComposite( this, SWT.NONE );
            parentPrpgteCmpst.setData( "name", "parentPrpgteCmpst" );
            toolkit.adapt( parentPrpgteCmpst );
            toolkit.paintBordersFor( parentPrpgteCmpst );
            parentPrpgteCmpst.setLayout( new GridLayout( 1, false ) );

            {
                requestCLbl = new CLabel( parentPrpgteCmpst, SWT.NONE );
                requestCLbl.setLayoutData( new GridData( SWT.CENTER, SWT.CENTER, true, false, 1, 1 ) );
                requestCLbl.setData( "name", "requestCLbl" );
                toolkit.adapt( requestCLbl );
                toolkit.paintBordersFor( requestCLbl );
                requestCLbl.setText( "Other Request(s)" );

            }

            {
                requestTxt = toolkit.createText( parentPrpgteCmpst, "New Text", SWT.BORDER | SWT.WRAP | SWT.V_SCROLL | SWT.MULTI );

                {
                    GridData gd_requestTxt = new GridData( SWT.FILL, SWT.FILL, true, true, 1, 1 );
                    gd_requestTxt.heightHint = 120;
                    requestTxt.setLayoutData( gd_requestTxt );

                }

                requestTxt.setText( "" );
                requestTxt.setData( "name", "requestTxt" );

            }

        }

    }   // end method createContents


    /**
     * Retrieves the <code>formValid</code> property from this bean.
     *
     * @created  April 21, 2011 8:08:28 PM by St Clair Clarke
     *
     * @return   <code>Boolean</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Boolean isFormValid()
    {
        return( requestTxt.getText()
                          .length() >= 2 );

    }   // end method isFormValid


    /**
     * Retrieves the <code>requestTxt</code> property from this bean.
     *
     * @created  April 21, 2011 8:06:17 PM by St Clair Clarke
     *
     * @return   <code>Text</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Text getRequestTxt()
    {
        return( requestTxt );

    }   // end method getRequestTxt

}   // end class OtherRqstForm
