/********************************************************************************
 * ePIMSs $Source$
 * ePIMSs $Project$
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author$
 *
 * @source $Source$
 * @path $FPath$

 * @project $Project$
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author$
 * @lastChangedDate $Date$
 *
 * @version $Revision$ $Date$
 *
 * @changeRequest $CR$
 * @state $State$
 ********************************************************************************/


package _com.epimss.lab.ui.toxicology;


import _com.epimss.lab.ui.misc.RequestDateAndNumberViewForm;

import _com.epimss.lab.ui.util.ViewFormHostPropagateCompositeVisibilityToggler;

import com.richclientgui.toolbox.propagate.PropagateComposite;

import org.eclipse.swt.SWT;

import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ViewForm;

import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import org.eclipse.ui.forms.widgets.FormToolkit;

import org.eclipse.wb.swt.SWTResourceManager;

/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  June 21, 2011 4:26:39 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
public class TherapeauticDrugScreenRqstViewForm extends Composite
{
    //~ Instance fields --------------------------------------------------------

    private final FormToolkit              toolkit                             = new FormToolkit( Display.getCurrent() );

    private CLabel                         therapeauticDrugsScreenRequestsCLbl;

    private PropagateComposite             rootPrpgteCmpst;
    private PropagateComposite             viewFormHostPrpgteCmpst;

    private RequestDateAndNumberViewForm   requestDateAndNumberViewForm;

    private TherapeauticDrugScreenRqstForm therapeauticDrugScreenRqstForm;

    private ViewForm                       viewForm;

    //~ public -----------------------------------------------------------------

    /**
     * Creates a new <code>TherapeauticDrugScreenRqstViewForm</code> object.
     *
     * @created  June 21, 2011 4:26:39 PM by St Clair Clarke
     *
     * @param    parent  <code>Composite</code> TODO!
     * @param    style   <code>int</code> TODO!
     *
     * @since    1.0
     */
    public TherapeauticDrugScreenRqstViewForm( Composite parent, int style )
    {
        super( parent, style );

        try
        {
            createContents();
            viewFormHostPrpgteCmpst.setVisible( false );

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.toxicology.TherapeauticDrugScreenRqstViewForm.TherapeauticDrugScreenRqstViewForm(parent, style), " + e );

        }   // end try-catch

    }   // end ctor TherapeauticDrugScreenRqstViewForm

    //~ Methods ----------------------------------------------------------------

    /**
     * The <code>createContents()</code> method TODO!
     *
     * @created  June 21, 2011 4:28:43 PM by St Clair Clarke
     * @since    1.0
     */
    private void createContents()
    {
        addDisposeListener( new DisposeListener()
            {
                @Override
                public void widgetDisposed( DisposeEvent e )
                {
                    toolkit.dispose();

                }   // end method widgetDisposed

            } );
        toolkit.adapt( this );
        toolkit.paintBordersFor( this );
        setLayout( new GridLayout() );

        {
            rootPrpgteCmpst = new PropagateComposite( this, SWT.NONE );
            rootPrpgteCmpst.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
            rootPrpgteCmpst.setData( "name", "rootPrpgteCmpst" );
            toolkit.adapt( rootPrpgteCmpst );
            toolkit.paintBordersFor( rootPrpgteCmpst );
            rootPrpgteCmpst.setLayout( new GridLayout( 1, false ) );

            {
                requestDateAndNumberViewForm = new RequestDateAndNumberViewForm( rootPrpgteCmpst, SWT.NONE );
                requestDateAndNumberViewForm.getRequestDateAndNumberForm()
                                            .getTestDateAndTimeCDT()
                                            .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                ViewFormHostPropagateCompositeVisibilityToggler.toggle( requestDateAndNumberViewForm, viewFormHostPrpgteCmpst );

                            }   // end method widgetSelected

                        } );
                requestDateAndNumberViewForm.getRequestDateAndNumberForm()
                                            .getRequestDateAndTimeCDT()
                                            .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                ViewFormHostPropagateCompositeVisibilityToggler.toggle( requestDateAndNumberViewForm, viewFormHostPrpgteCmpst );

                            }   // end method widgetSelected

                        } );
                requestDateAndNumberViewForm.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                requestDateAndNumberViewForm.setData( "name", "requestDateAndNumberViewForm" );
                toolkit.adapt( requestDateAndNumberViewForm );
                toolkit.paintBordersFor( requestDateAndNumberViewForm );

            }

            {
                viewFormHostPrpgteCmpst = new PropagateComposite( rootPrpgteCmpst, SWT.NONE );
                viewFormHostPrpgteCmpst.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                viewFormHostPrpgteCmpst.setData( "name", "viewFormHostPrpgteCmpst" );
                toolkit.adapt( viewFormHostPrpgteCmpst );
                toolkit.paintBordersFor( viewFormHostPrpgteCmpst );
                viewFormHostPrpgteCmpst.setLayout( new GridLayout( 1, false ) );

                {
                    viewForm = new ViewForm( viewFormHostPrpgteCmpst, SWT.BORDER );
                    viewForm.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                    viewForm.setData( "name", "viewForm" );
                    toolkit.adapt( viewForm );
                    toolkit.paintBordersFor( viewForm );

                    {
                        therapeauticDrugScreenRqstForm = new TherapeauticDrugScreenRqstForm( viewForm, SWT.NONE );
                        therapeauticDrugScreenRqstForm.setData( "name", "therapeauticDrugScreenRqstForm" );
                        toolkit.adapt( therapeauticDrugScreenRqstForm );
                        toolkit.paintBordersFor( therapeauticDrugScreenRqstForm );
                        viewForm.setContent( therapeauticDrugScreenRqstForm );
                        therapeauticDrugScreenRqstForm.setLayout( new GridLayout( 1, false ) );

                    }

                    {
                        therapeauticDrugsScreenRequestsCLbl = new CLabel( viewForm, SWT.NONE );
                        therapeauticDrugsScreenRequestsCLbl.setFont( SWTResourceManager.getFont( "Segoe UI", 9, SWT.BOLD ) );
                        therapeauticDrugsScreenRequestsCLbl.setData( "name", "therapeauticDrugsScreenRequestsCLbl" );
                        toolkit.adapt( therapeauticDrugsScreenRequestsCLbl );
                        toolkit.paintBordersFor( therapeauticDrugsScreenRequestsCLbl );
                        viewForm.setTopLeft( therapeauticDrugsScreenRequestsCLbl );
                        therapeauticDrugsScreenRequestsCLbl.setText( "Therapeautic Drugs Screen Requests" );

                    }

                }

            }

        }

    }   // end method createContents


    /**
     * Retrieves the <code>requestDateAndNumberViewForm</code> property from this bean.
     *
     * @created  June 21, 2011 4:57:02 PM by St Clair Clarke
     *
     * @return   <code>RequestDateAndNumberViewForm</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected RequestDateAndNumberViewForm getRequestDateAndNumberViewForm()
    {
        return( requestDateAndNumberViewForm );

    }   // end method getRequestDateAndNumberViewForm


    /**
     * Retrieves the <code>therapeauticDrugScreenRqstForm</code> property from this bean.
     *
     * @created  June 21, 2011 4:57:02 PM by St Clair Clarke
     *
     * @return   <code>TherapeauticDrugScreenRqstForm</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected TherapeauticDrugScreenRqstForm getTherapeauticDrugScreenRqstForm()
    {
        return( therapeauticDrugScreenRqstForm );

    }   // end method getTherapeauticDrugScreenRqstForm

}   // end class TherapeauticDrugScreenRqstViewForm
